<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("user/create_user.php?action=create");
  Head();
  include("../include/checks.php");
?>

<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>

<?
function debug ($a) {
//   print "debug: $a<br>\n";
}

debug("debug is on");

$errors = array();
$valid_actions = array('save','firstsave','modify','create','delete','kill');

if (!empty($HTTP_GET_VARS['action']) && 
    in_array($HTTP_GET_VARS['action'],$valid_actions)) $action = trim(urldecode($HTTP_GET_VARS['action']));
   else array_push($errors, "Error: need valid action to proceed");

$dn="";
if (!empty($HTTP_GET_VARS['dn'])) $dn = trim(urldecode($HTTP_GET_VARS['dn']));

if (!($uid = $_SERVER['PHP_AUTH_USER']) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid)))
   array_push($errors, "Internal Error: could not get Authentication Information");

if (!$errors && $group != "maintainer" && $group != "admin" && 
    !($group == "user" && $dn == $bind_dn)) 
   array_push($errors, "Error: You don't have the required Permissions"); 

debug("givenuid=$uid, bind_dn=$bind_dn, dn='$dn', group=$group");

$myself = $_SERVER['PHP_SELF'];

if (!empty($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (!empty($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

$attributes = array( 'title', 'cn', 'sn', 'uid', 'mail', 'alias', 'o',
                     'ou', 'roomNumber', 'street', 'postOfficeBox',
                     'postalCode', 'l', 'c', 'telephoneNumber',
                     'facsimileTelephoneNumber', 'userPassword' );

$utf8 = array ( 'cn', 'title', 'o', 'ou', 'roomNumber', 'street', 'sn',
                'postOfficeBox', 'postalCode', 'l', 'c', 'telephoneNumber',
                'facsimileTelephoneNumber' );
function to_utf8 ($a)
{
   global $utf8;
   global $attributes;
   $utf8_ecnoded = true;
   foreach ($attributes as $attr) {
      if (!in_array($attr,$utf8) || empty($a[$attr])) continue;
      if (is_array($a[$attr])) {
         $index = 0;
         while (!empty($a[$attr][$index])) {
            $a[$attr][$index] = utf8_encode($a[$attr][$index]);
            $index++;
         }
      } elseif (!empty($a[$attr])) $a[$attr] = utf8_encode($a[$attr]);
   }
   return $a;
}

function from_utf8 ($a)
{
   global $utf8;
   global $attributes;
   foreach ($attributes as $attr) {
      if (!in_array($attr,$utf8) || empty($a[$attr])) continue;
      if (is_array($a[$attr])) {
         $index = 0;
         while (!empty($a[$attr][$index])) {
            $a[$attr][$index] = utf8_decode($a[$attr][$index]);
            $index++;
         }
      } elseif (!empty($a[$attr])) $a[$attr] = utf8_decode($a[$attr]);
   }
   return $a;
}

function fill_up($a)
{
   global $attributes;
   foreach ($attributes as $attr) {
      if ($attr == 'uid' || $attr == 'mail') continue;
      if (empty($a[$attr])) $a[$attr] = array();
   }
   return $a;
}

function fill_up2 ($a)
{
   global $attributes;
   foreach ($attributes as $attr) {
      if ($attr == 'uid' || $attr == 'mail') continue;
      if (empty($a[$attr])) $a[$attr] = array(0 => "", 'count' => 1);
   }
   return $a;
}


$beautify = array (
      'c' => 'Country', 'l' => 'City', 'street' => 'Street Address', 'telephoneNumber' => 'Telephone Number',
      'postOfficeBox' => 'Postbox', 'postalCode' => 'Postal Code', 'ou' => 'Organizational Unit',
      'o' => 'Organization', 'roomNumber' => 'Room Number', 'title' => 'Title', 'cn' => 'Name',
      'sn' => 'Surname', 'facsimileTelephoneNumber' => 'Fax Number', 'mail' => 'Primary E-Mail Address',
      'alias' => 'E-Mail Alias', 
      #'uid' => 'Unique UserID', 
      'userquota' => 'Mailbox Size Limit',
      'userPassword' => 'Password', 'firstname' => 'First Name', 'lastname' => 'Last Name');

function dobeautify ($a)
{
   global $beautify;
   if (array_key_exists($a, $beautify)) return $beautify[$a];
   return $a;
}

if ($action == "create") {
  $comment_mail_0 = 'Required, non volatile' ; }
else {
  $comment_mail_0 = 'non volatile' ;
}

$comment = array(
   'firstname' => 'Required', 'sn_0' => 'Required',
   'password_0' => 'Required', 'password_1' => 'Required',
   'mail_0' => $comment_mail_0,
   'visible' => 'check here to make this users address <br> visible in the address book');

function comment ($a)
{
   global $comment;
   if (array_key_exists($a, $comment)) return $comment[$a];
   return '';
}

$blacklist = array('cn', 'sn', 'uid', 'mail', 'userPassword');

function black ($a)
{
   global $blacklist;
   return in_array($a,$blacklist);
}

$noshow = array('objectClass','cn','sn', 'mail', 'userPassword', 'uid');


function noshow ($a)
{
   global $noshow;
   return in_array($a, $noshow);
}


$firstname = "";
$lastname = "";
$password_0 = "";
$password_1 = "";
$mail_0 = "";
$domain = "";
$domain_dn = "";
$visible = true;
if (strstr($dn, "cn=internal")) $visible = false; 

$missing_input = 0;

function missing_input ()
{
   global $missing_input;
   global $errors;
   
   if (!$missing_input) {
      $missing_input++;
      array_push($errors, "Error: Input required");
   }
}

function is_unique ($a, $b)
{
   global $link;
   if (($result = ldap_search($link,$_SESSION['base_dn'],"(".$a."=".$b.")")) &&
       (ldap_count_entries($link,$result) <= 0))
      return TRUE;
   return FALSE;
}


$ldap_object = array('objectClass' => "inetOrgPerson");

if (!$errors && (!($link = ldap_connect($ldap_server,$ldap_port)) || 
    !ldap_bind($link, $bind_dn, $_SERVER["PHP_AUTH_PW"])))
   array_push($errors, "Communication Error: could bind to ldap://$ldap_server:$ldap_port ".ldap_error($link));
if (!$errors) {
   // ldap_set_option($link, LDAP_OPT_PROTOCOL_VERSION, 3);
   if (($result = ldap_read($link, $_SESSION['base_dn'], "(objectclass=*)")) &&
       ($entry = ldap_first_entry($link,$result)) &&
       ($dattrs = ldap_get_attributes($link,$entry))) {

      $domain = $dattrs['postfix-mydomain'][0];
      $dcs = array_reverse(explode('.', $domain));
      $domain_dn = $_SESSION['base_dn'];
      foreach ($dcs as $dc) $domain_dn = "dc=$dc,".$domain_dn;

   } else array_push($errors, "LDAP Error: could not determin domain");
   $domain_dn = $_SESSION['base_dn'];

   if ($action == "kill") {

      if (!$dn) array_push($errors, "Error: need dn for delete operation");
         elseif ($group != "maintainer" && $group != "admin") 
            array_push($errors, "Error: you need administrative permissions to delete users");

      if (!$errors) {    
         print("<TR><TD><center><H1> Delete User </H1></center></TD></TR>\n");
         $delete_template['deleteflag'] = 'TRUE';
         if (!(ldap_modify($link,$dn,$delete_template))) {
            array_push($errors, "LDAP Error: could not mark ".utf8_decode($dn)." for deletion ".ldap_error($link));
         } else {
//            system("sudo -u kolab /kolab/etc/kolab/kolab_buildconfig &");
            print("<tr><td><center> The object ".utf8_decode($dn)." has been deleted </td></tr>\n");
         }
      } 

   } else {

      switch ($action) {

         case "firstsave":
            #if (!empty($HTTP_GET_VARS['uid_0']) &&
            #    uid_ok($HTTP_GET_VARS['uid_0'])) {
            #   $ldap_object['uid'] = trim(strtolower(urldecode($HTTP_GET_VARS['uid_0']))); 
            #   // $ldap_object['mail'] = $ldap_object['uid']."@".$domain;
            #} else {
            #   $comment['uid_0'] = "<span style=\"color:#FF0000\"> Fill in valid uid (lowercase <br>
	    #                        letters and digits only, e. g. jblack)</span>";
            #   missing_input();
            #}
	    if (empty($HTTP_GET_VARS['mail_0'])) {
	       $comment['mail_0'] = "<span style=\"color:#FF0000\"> Fill in valid email address</span>";
	       missing_input();
            }

         case "save":
            if ($action == "save" && !$dn) array_push($errors, "Internal Error: need dn to save");
	    if ($group == "admin" || $group == "maintainer") {
               if (!empty($HTTP_GET_VARS['firstname'])) {
                  $firstname = trim(urldecode($HTTP_GET_VARS['firstname']));
               } else {
                  $comment['firstname'] = "<span style=\"color:#FF0000\"> Fill in firstname </span>";
                  missing_input();
               }
               if (!empty($HTTP_GET_VARS['lastname'])) {
                  $ldap_object['sn'] = trim(urldecode($HTTP_GET_VARS['lastname']));
                  if ($firstname) $ldap_object['cn'] = $firstname." ".$ldap_object['sn'];
               } else {
                  $comment['lastname'] = "<span style=\"color:#FF0000\"> Fill in lastname </span>";
                  missing_input();
               }
	    }   
            if (!empty($HTTP_GET_VARS['password_0'])) $password_0 = urldecode($HTTP_GET_VARS['password_0']);
            else {
               $comment['password_0'] = "<span style=\"color:#FF0000\"> Fill in password </span>";
               missing_input();
            }
            if (!empty($HTTP_GET_VARS['password_1'])) $password_1 = urldecode($HTTP_GET_VARS['password_1']);
            else {
               $comment['password_1'] = "<span style=\"color:#FF0000\"> Fill in password </span>";
               missing_input();
            }
            if ($password_0 && $password_1) {
               if ($password_0 == $password_1) {
                  $ldap_object['userPassword'] = $password_0;
               } else {
                  $comment['password_1'] = "<span style=\"color:#FF0000\"> Passwords do not match </span>"; 
                  missing_input();
               }
            }

            if (!empty($HTTP_GET_VARS['mail_0']) && !is_unique($HTTP_GET_VARS['mail_0'])) {
               $ldap_object['mail'] = trim(strtolower(urldecode($HTTP_GET_VARS['mail_0'])));
	       if ($action == "firstsave") $ldap_object['uid'] = $ldap_object['mail']; 
            } else {
               $comment['mail_0'] = "<span style=\"color:#FF0000\">email address is already taken by another user</span>";
               missing_input();
            }

            foreach ($attributes as $attr) {
               if (black($attr)) continue;
               $count = 0;
               $key = $attr."_0";
               $args = array();
               while (!empty($HTTP_GET_VARS[$key])) {
                  $args[$count] = trim(urldecode($HTTP_GET_VARS[$key]));
                  $count++;
                  $key = $attr."_".$count;
               }
               if ($count > 0) $ldap_object[$attr] = $args;
                  elseif (!empty($HTTP_GET_VARS[$key])) $ldap_object[$attr] = $HTTP_GET_VARS[$key];
            }
	    if ($group == "maintainer" || $group == "admin") {
               if (!empty($HTTP_GET_VARS['visible']) && $HTTP_GET_VARS['visible'] == "true") 
	          $visible = true;
	       else $visible = false;
	    }   
            if (!$visible) $dn_add = ",cn=internal";
               else $dn_add = "";
//print("ldap_object: "); print_r($ldap_object); print("<br>");

	    #if (!empty($ldap_object['uid']) && !is_unique('uid',$ldap_object['uid'])) {
	    #   $comment['uid_0'] = "<span style=\"color:#FF0000\"> Error: This uid is already taken by another user </span>";
	    #   missing_input();
	    #}
	    if (!empty($ldap_object['alias']) && !is_unique('alias',$ldap_object['alias'])) {
	       $comment['alias_0'] = "<span style=\"color:#FF0000\"> Error: the alias you gave is <br>". 
	       			     "already taken by another user</span>";
	       missing_input();
	    }
            $ldap_object = to_utf8($ldap_object);
            if ($action == "save") {
               if (!$errors) {
                  if (!empty($ldap_object['cn'])) $newdn = "cn=".$ldap_object['cn'].",".$domain_dn;
                     else $newdn = $dn;
                  if (!$visible && !strstr($newdn,$dn_add)) {
                     list($cn,$rest) = split(',', $newdn, 2); 
                     $newdn = $cn.$dn_add.",".$rest;
                  } 
                  if (strcmp($dn,$newdn) != 0) {
                     if (($result=ldap_read($link,$dn,"(objectclass=*)")) &&
                         ($entry=ldap_first_entry($link,$result)) &&
                         ($oldattrs=ldap_get_attributes($link,$entry))) {
                        $ldap_object['uid'] = $oldattrs['uid'][0];
                        $ldap_object['mail'] = $oldattrs['mail'][0];
                        if (!ldap_add($link,$newdn, $ldap_object) || !ldap_delete($link,$dn))
                           array_push($errors, "LDAP Error: could not rename $dn to $newdn ".ldap_error($link));
                        $dn = $newdn;
                     } else array_push($errors,"LDAP Error: could not read $dn ".ldap_error($link));
                  } else {
                     $ldap_object = fill_up($ldap_object);
                     if ($group == "user") {
                        unset($ldap_object['sn']);
                        unset($ldap_object['cn']);
                     }
                     if (!ldap_modify($link, $dn, $ldap_object))
                     array_push($errors, "LDAP Error: could not modify object $dn ".ldap_error($link)); 
                  }
               } 
            } else {
               if (!$errors) {
                  $dn = "cn=".$ldap_object['cn'].$dn_add.",".$domain_dn;
                  if ($dn && !ldap_add($link, $dn, $ldap_object)) 
                     array_push($errors, "LDAP Error: could not add object $dn ".ldap_error($link));
//                     else system("sudo -u kolab /kolab/etc/kolab/kolab_buildconfig &");
               }
               if ($errors) {
                  print("<TR><TD><center><H1> Create New User </H1></center></TD></TR>\n");
 		  $blacklist = array('mail');
		  $action = "create";
		  $ldap_object = from_utf8($ldap_object);
                  break;
               }
            }
            $action = "modify";
            print("<TR><TD><center><H1> Modify Existing User </H1></center></TD></TR>\n");
            break;

         case "create":
            print("<TR><TD><center><H1> Create New User </H1></center></TD></TR>\n");
            $blacklist = array('mail');
            break;

         case "modify":
            print("<TR><TD><center><H1> Modify Existing User </H1></center></TD></TR>\n");
	    break;

	 case "delete":
	    print("<TR><TD><center><H1> Confirm Delete User </H1></center></TD></TR>\n");
      }

      if ($dn) {
         $ldap_object = array();
         if (($result = ldap_read($link, $dn, "(objectclass=*)")) &&
             ($entry = ldap_first_entry($link,$result)) &&
             ($ldap_object = ldap_get_attributes($link,$entry))) {
            $ldap_object = from_utf8($ldap_object);
            $ldap_object = fill_up2($ldap_object);
            ldap_free_result($result);
         } else array_push($errors, "LDAP Error: could not read $dn ".ldap_error($link));
      }
   }
   ldap_close($link);
}   

$width = 50;

//print "ldap_object gelesen: "; print_r($ldap_object); print "<br>";

if (in_array($action, $valid_actions) && $action != "kill") {
print "<TR><TD><CENTER><form action=\"$myself\" method=\"GET\">\n";
switch ($action) {
   case "create":
      print("<input type=\"hidden\" name=\"action\" value=\"firstsave\">\n");
      break;
   case "delete":
      print("<input type=\"hidden\" name=\"action\" value=\"kill\">\n");
      break;
   default:
      print("<input type=\"hidden\" name=\"action\" value=\"save\">\n");
}
if ($dn) print "<input type=\"hidden\" name=\"dn\" value=\"$dn\">\n";
print "<table cellspacing=0 cellpadding=3>\n";

if (is_array($ldap_object['sn'])) $lastname = $ldap_object['sn'][0];
   else $lastname = $ldap_object['sn']; 
if (is_array($ldap_object['cn'])) $cn = $ldap_object['cn'][0];
   else $cn = $ldap_object['cn'];
if ($lastname) {
   $a = strlen($lastname); 
   if ($cn) {
      $b = strlen($cn);
      $firstname = substr($cn, 0, $b - $a);
   }
}
if ($action == "delete") print("<tr><th> Attribute </th><th> Value </th></tr>\n");
else print("<tr><th> Attribute </th><th> Value </th><th> Comment </th></tr>\n");
print "<tr><td> First Name </td><td>\n";
if ($action == "delete") print("$firstname </td></tr>\n");
else {
   if ($group == "admin" || $group == "maintainer") {
      print "<input type=\"text\" name=\"firstname\" size=$width maxlength=80 value=\"$firstname\">\n";
      print "</td><td>".(comment('firstname'))."</td></tr>\n";
   } else print("$firstname </td><td> &nbsp; </td></tr>\n");
}

print "<tr><td> Last Name </td><td>\n";
if ($action == "delete") print("$lastname </td></tr>\n");
else {
   if ($group == "admin" || $group == "maintainer") {
      print "<input type=\"text\" name=\"lastname\" size=$width maxlength=80 value=\"$lastname\">\n";
      print "</td><td>".(comment('sn_0'))."</td></tr>\n";
   } else print("$lastname </td><td> &nbsp; </td></tr>\n");
}

if ($action != "delete") {
   if (is_array($ldap_object['userPassword'])) $password_0 = $password_1 = $ldap_object['userPassword'][0];
      else $password_0 = $password_1 = $ldap_object['userPassword'];
   print "<tr><td> Password </td><td>\n";
   print "<input type=\"password\" name=\"password_0\" size=$width maxlength=80 value=\"$password_0\">\n";
   print "</td><td>".(comment('password_0'))."</td></tr>\n";
   print "<tr><td> Verfiy Password </td><td>\n";
   print "<input type=\"password\" name=\"password_1\" size=$width maxlength=80 value=\"$password_1\">\n";
   print "</td><td>".(comment('password_1'))."</td></tr>\n";
   print "<tr><td> Primary Email Address</td><td>\n";
   if (is_array($ldap_object['mail'])) $mail_0 = $ldap_object['mail'][0];
      else $mail_0 = $ldap_object['mail'];
   print "<input type=\"text\" ";
   if ($action != "create") { 
     print " readonly "; 
   } 
   print "name=\"mail_0\" size=$width maxlength=80 value=\"$mail_0\">\n";
   print "<td>".(comment('mail_0'))."</td></tr>\n";
}

foreach ($attributes as $attr) {
   if (noshow($attr)) continue;
   if (!empty($ldap_object[$attr])) {
      if (is_array($ldap_object[$attr])) $value = $ldap_object[$attr];
         else $value = array(0 => $ldap_object[$attr], 'count' => 1);
   } else $value = array( 0 => "", 'count' => 1);
   for ($count=0; $count<$value['count']; $count++) {
      $battr = dobeautify($attr);
      print "<tr><td> $battr </td><td>\n";
      if ($action != "delete") {
         if (!black($attr)) {
            print "<input type=\"text\" name=\"".$attr."_".$count."\" size=$width maxlength=80 value=\"".$value[$count]."\">\n";
         } else {
            if ($value[$count]) print "$value[$count]";
               else print "(not set)";
         }
         print "</td><td>".(comment($attr."_".$count))."</td></tr>\n";
      } else print($value[$count]." </td></tr>\n");
      $count++;
   }
}
if ($action != "delete") {
   if ($group == "admin" || $group == "maintainer") {
      print("<tr><td>Addressbook</td><td><input type=\"checkbox\" name=\"visible\" value=\"true\" ");
      if ($visible) print("checked");
      print("></td>\n");
      print "<td>".(comment('visible'))."</td></tr>\n";
   }
}

print "</table></CENTER></TD><TR>\n";

print "<tr><td><center><table cellspacing=0 cellpadding=3>\n";
print "<tr><td><input type=\"image\" src=\"../pics/button_ok.png\" name=\"apply\" value=\"Apply\"></td>\n";
if ($group == "user") {
   print "<td><a href=\"..\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
} else {
   print "<td><a href=\"index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
}
print "</center></td></tr>\n";

} // if $action != delete

print("</table>\n");

if ($errors) {
   print("<TABLE WIDTH=\"100%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n");
   print("<TR><TD HEIGHT=20></TD></TR>\n");
   print("<TR><TD><H3> There were Errors : </H3></TD></TR>\n");
   print("<TR><TD>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>");
   print("</TD></TR>\n");
   print("</TABLE>\n");
}
Foot();
?>
